#pragma once
#include <ESP8266WiFi.h>
#include <WiFiClientSecure.h>
#include <ESP8266HTTPClient.h>
#include <Arduino_JSON.h>
#include "rootCertificate.hpp"
#include "TeaData.hpp"

class TeaNetworking
{
public:
    void init(const char *ssid, const char *password);
    JSONVar httpsGETRequest(String serverName);
    JSONVar httpsPOSTRequest(String serverName, String data);
    JSONVar httpsPUTRequest(String serverName, String data);
    bool wifiConnected() { return WiFi.status() == WL_CONNECTED; }
    String createTeaData(
        String teaname,
        String rfidcode,
        int watertemp,
        int steepingseconds);
    String createTeaData(TeaData tea);
    String bundleNewTeaInfo(String rfidCode, int steepigSeconds);
    String bundleTeaMetaChange(String teaName, String teaNotes, int waterTemp, int steepingSeconds);
    String bundleSteepingTimeLogEntry(int steepigSeconds);
};