#include "TeaTimer.hpp"

TeaTimer::TeaTimer(SmartServo *t_servo)
{
    m_servo = t_servo;
}

// Move servo down, start timer.
void TeaTimer::beginSteeping(unsigned long t_steepingDuration)
{
    if (m_isSteeping)
        return;
    m_servo->moveServoTo(125, 2);
    m_endSteepingTime = millis() + t_steepingDuration;
    m_isSteeping = true;
}

// Move servo up, stop timer immediately.
void TeaTimer::endSteeping()
{
    m_servo->moveServoToZero();
    m_isSteeping = false;
}

// Called at start of update.
void TeaTimer::tick()
{
    if (millis() >= m_endSteepingTime && m_isSteeping)
    {
        endSteeping();
    }
}

unsigned long TeaTimer::remainingSteepTimeSeconds()
{
    return (m_endSteepingTime - millis()) / 1000;
}